Markdown - простой и удобный язык разметки. Благодаря его популярности, существует множество программ и сервисов, которые так или иначе с ним взаимодействуют. Практически каждый README на GitHub использует Markdown, также он используется на многих сайтах для написания статей или даже книг.

В статье даётся быстрый старт для начинающих, а также множество инструментов для упрощения повседневной работы.

## Применение

Markdown может быть использован для ведения ежедневных заметок, блогов, в мессенджерах, для описания проектов, для составления презентаций и даже как основа для целого сайта.


## Синтаксис

### Заголовки 

В Markdown, как и в HTML, есть 6 уровней заголовков. В html они обозначаются так:

    <h1>Заголовок первого уровня</h1>
    <h2>Заголовок второго уровня</h2>

В Markdown — при помощи символа решетки. Количество решеток обозначает уровень заголовка:

```
# Заголовок первого уровня
## Заголовок второго уровня
### Заголовок третьего уровня
#### Заголовок четвёртого уровня
##### Заголовок пятого уровня
###### Заголовок шестого уровня
```

### Форматирование

`_курсив_` _курсив_

`**жирный**` **жирный**

`~~зачёркнутый~~` ~~зачёркнутый~~

``моноширинный`` `моноширинный`

```
> цитата
> вторая строка цитаты
```

> цитата
> вторая строка цитаты

Разделитель:

`---` 

---


> Это цитата с _курсивным_ **жирно-_курсивным_** `моноширинным` текстом


### Ссылки и изображения

Формат ссылки: `[описание](ссылка)`

`[Домашняя страница](http://annimon.com/)`  [Домашняя страница](http://annimon.com/)

В описании ссылки можно применять форматирование текста:

`[_Домашняя_ `страница`](http://annimon.com/)`  [_Домашняя_ `страница`](http://annimon.com/)

Формат картинки такой же, только в начало добавляется восклицательный знак: `![описание](ссылка на изображение)`

![логотип Markdown](markdown-logo.png)

Попробуйте теперь сделать картинку-ссылку.

`[![логотип Markdown](markdown-logo.png)](https://ru.wikipedia.org/wiki/Markdown)`
[![логотип Markdown](markdown-logo.png)](https://ru.wikipedia.org/wiki/Markdown)

### Списки

Списки вы наверняка применяете их в текстовых файлах, в Markdown это стандарт:

- первый пункт
- второй пункт
- третий пункт

Нумерованный список:

1. Первый пункт.
2. Второй пункт.

Вложенный список:

- Первый пункт
  - Первый подпункт
  - Второй подпункт
    - Третий уровень вложенности
- Второй пункт
  1. Подпункт 1
  2. Подпункт 2


### Код

```java
class Main {

  public static void main(String[] args) {
  }
}
```

```javascript
alert('Example');
```

### HTML

Кроме всего перечисленного, Markdown поддерживает html-теги. Так что, если чего-то не хватает, например, надстрочного текста, можно использовать html-теги.

```
x<sup>2</sup>
```

x<sup>2</sup>


## Онлайн-редакторы

* https://jbt.github.io/markdown-editor/ простой редактор. Для небольших текстов формирует ссылку, вот [пример](https://jbt.github.io/markdown-editor/#fc8xCoAwDAXQ3VMEetFaBx2E4uQ1pNJFsV7h50b+dk4dEgjJ4xNxgh0HThTcrMS6BC+y+jZwITpxqLtH4yDOJkkDSruziGk08Cizr8i2stlcEQM39TW0QzufafwzduDCwNFkHw==).
* http://dillinger.io/ - редактор для писателей. Отличный дизайн, подсчет количества слов, возможность экспорта в html, pdf, а также на популярные сайты и облачные хранилища.
* https://stackedit.io/editor - помимо основных функций редактора умеет конвертировать HTML в md. Есть панель для быстрого форматирования, публикация на множество ресурсов, поддержка LaTeX, гибкие настройки.
* https://write-box.appspot.com/ - ещё один редактор для писателей с простым и лаконичным дизайном.


## Редакторы для ПК

* [CuteMarkEd](https://cloose.github.io/CuteMarkEd/) - кроссплатформенный редактор с открытыми исходниками и возможностью создания презентаций. Именно в нём сейчас и пишется эта статья :)  
  ![CuteMarkEd](cutemarked.png)
* [MdCharm](http://www.mdcharm.com/) - ничуть не уступает остальным редакторам. Из достоинств: возможность установки собственных CSS-стилей, открытие папки как проекта, вкладки.


## Плагины для IDE и других редакторов

* [Markdown support для IntelliJ IDEA](https://plugins.jetbrains.com/idea/plugin/7793-markdown-support)
* [Markdown support для NetBeans IDE](http://plugins.netbeans.org/plugin/50964/markdown-support)
* [Markdown preview для Sublime Text 2/3](https://github.com/revolunet/sublimetext-markdown-preview)
* [markdown-preview](https://atom.io/packages/markdown-preview), [markdown-preview-plus](https://atom.io/packages/markdown-preview-plus) для Atom


## Прочие инструменты

### Редакторы презентаций

* [Marp - Markdown Presentation Writer](https://yhatt.github.io/marp/) — кроссплатформенный редактор презентаций.  
  ![Marp](marp.png)
* [Madoko](https://www.madoko.net/editor.html) — онлайн-редактор презентаций.
* [remark](https://github.com/gnab/remark) — JavaScript-библиотека для создания презентаций. Использует Markdown.

### Редакторы заметок

* [Simplenote](https://simplenote.com/) - сервис для заметок с поддержкой Markdown и синхронизацией. Есть веб-клиент, клиент для ПК и Android.
* [NoticEditor](https://github.com/NoticEditorTeam/NoticEditor) - оффлайновый иерархический редактор заметок.

### Генераторы сайтов

* [Jekyll](https://jekyllrb.com/) - используется в [GitHub Pages](https://pages.github.com/). Блог, страница портфолио, описание проекта, всё это можно сгенерировать из Markdown-файла и получить красивую веб-страничку.
* [Hexo](https://hexo.io/) - генератор блогов на Node.js.  
  ![Hexo](hexo.png)
* [GitBook](https://www.gitbook.com/) - пригодится для книг или документации. Особенность GitBook в том, что для открытых проектов они предоставляют место на своём сервере. Отличный вариант для размещения (и продвижения) своих проектов. В свободное время можно что-нибудь почитать [в галерее](https://www.gitbook.com/explore).
* [StaticGen](https://www.staticgen.com/) - огромный список статических генераторов сайтов.

### Ковертеры в другие форматы

* [Pandoc](http://pandoc.org/) - универсальная программа для конвертирования различных текстовых форматов.
* [md2bb](https://github.com/White-Oak/md2bb) - настраиваемый конвертер из Markdown в BB-code.
* [Онлайн конвертер Markdown в PDF](http://www.markdowntopdf.com/)

### Стили CSS

* [Markdown CSS](https://markdowncss.github.io/)
* [Markedstyle](http://markedstyle.com/styles)


## Практика. Быстрое создание страницы описания проекта

Предположим, что у нас есть проект и очень мало времени на то, чтобы сделать страницу с его описанием. Обычный txt нас не устраивает, мы хотим красивую html-страницу. Набирать вручную html-теги слишком долго, подбирать цвета и стили для текста, тем более. Что делать?

Начинаем с самого текста.

```
# Мой крутейший проект

Свершилось! Представляю Вашему вниманию свой **крутейший проект**. С его помощью наконец-то решается задача, которую прежде тяжело было решить. Больше не нужно покупать десятки дорогих решений, которые затрагивают проблему лишь частично. Всё это в прошлом.

## Возможности

 Мой крутейший проект имеет множество восхитительных функций, вот они:

 - Быстрое решение проблемы.
 - Возможность запуска на любой платформе.
 - Для решения задачи вам не понадобится мощное железо, программа работает даже на тетрисе!!
 - Интуитивно понятный интерфейс.
 - И всё это **бесплатно**!

## Как это работает

Всё очень просто. Вам достаточно установить программу на своё устройство и запустить. Она сама сделает всё за вас и уведомит по окончанию работы. Вы также можете нажать `X` для того, чтобы завершить программу. При следующем запуске, она продолжит свою работу.
```

Далее, открываем этот текст в любом редакторе, который умеет экспортировать html. Для примера возьмём [dillinger.io](http://dillinger.io/).

![Описание проекта на Dillinger](dillinger.png)
 
Экспортируем в обычный html. Мы, конечно же, можем экспортировать в стилизованный html, но, допустим, нас не устраивает результат.

![Экспорт в HTML](dillinger-export.png)

[Полученный результат](http://projects.annimon.com/samples/other/CoolProject.html).

Ищем подходящий стиль на сайтах [Markdown CSS](https://markdowncss.github.io/) или [Markedstyle](http://markedstyle.com/styles).

Допустим, нам понравился [Modest](http://markdowncss.github.io/modest/). Первая же ссылка ведёт на GitHub, откуда можно скопировать [стиль](https://github.com/markdowncss/modest/blob/master/css/modest.css).

Копируем содержимое css-файла и вставляем между тегов `<style></style>` сгенерированного ранее html.

Получаем [такую страницу](http://projects.annimon.com/samples/other/CoolProject-styled.html). При желании, можно заменить стиль на любой другой.


Напоследок, выкладываю файл этой же статьи в Markdown.